Index: doc/filesystem/Makefile
===================================================================
--- doc/filesystem/Makefile	(revision 482ffbb27d1db5c3b0362bdcb9f935beb9d514c2)
+++ doc/filesystem/Makefile	(revision 7441fe2c5b1275339177a1aef778c9a9620dc462)
@@ -22,7 +22,7 @@
 COMMON_FILES=../common/cpright.texi ../common/setup.texi
 
-GENERATED_FILES=basefs.texi applayering.texi patheval.texi \
-    init.texi mounting.texi lifecycle.texi imfs.texi \
-    syscalls.texi basefs.texi
+GENERATED_FILES=patheval.texi \
+    init.texi mounting.texi fsrequirements.texi imfs.texi \
+    syscalls.texi
 
 FILES= $(PROJECT).texi \
@@ -54,14 +54,4 @@
 	cp $(PROJECT).dvi $(WWW_INSTALL)/$(PROJECT)
 
-basefs.texi: basefs.t Makefile
-	$(BMENU) -p "Preface" \
-	   -u "Top" \
-	   -n "" ${*}.t
-
-applayering.texi: applayering.t Makefile
-	$(BMENU) -p "" \
-	   -u "Top" \
-	   -n "" ${*}.t
-
 patheval.texi: patheval.t Makefile
 	$(BMENU) -p "" \
@@ -79,5 +69,5 @@
 	   -n "" ${*}.t
 
-lifecycle.texi: lifecycle.t Makefile
+fsrequirements.texi: fsrequirements.t Makefile
 	$(BMENU) -p "" \
 	   -u "Top" \
Index: doc/filesystem/filesystem.texi
===================================================================
--- doc/filesystem/filesystem.texi	(revision 482ffbb27d1db5c3b0362bdcb9f935beb9d514c2)
+++ doc/filesystem/filesystem.texi	(revision 7441fe2c5b1275339177a1aef778c9a9620dc462)
@@ -64,10 +64,8 @@
 
 @include preface.texi
-@include basefs.texi
-@include applayering.texi
 @include patheval.texi
 @include init.texi
 @include mounting.texi
-@include lifecycle.texi
+@include fsrequirements.texi
 @include imfs.texi
 @include syscalls.texi
@@ -80,10 +78,8 @@
 @menu
 * Preface::
-* Base Filesystem::
-* Applications and Functional Layering::
 * Pathname Evaluation::
 * System Initialization::
 * Mounting and Unmounting Filesystems::
-* Filesystem Lifecycle::
+* Filesystem Requirements::
 * In-Memory Filesystem::
 * System Call Development Notes::
Index: doc/filesystem/fsrequirements.t
===================================================================
--- doc/filesystem/fsrequirements.t	(revision 482ffbb27d1db5c3b0362bdcb9f935beb9d514c2)
+++ doc/filesystem/fsrequirements.t	(revision 7441fe2c5b1275339177a1aef778c9a9620dc462)
@@ -13,5 +13,83 @@
 implementations must adhere to.
 
-@section Filesystem File and Directory Removal Constraints
+@section General
+
+The RTEMS filesystem framework was intended to be compliant with the
+POSIX Files and Directories interface standard. The following filesystem
+characteristics resulted in a functional switching layer.
+
+@example
+Figure of the Filesystem Functional Layering goes here.
+This figure includes networking and disk caching layering.
+@end example
+
+@ifset use-ascii
+@example
+@group
+@end group
+@end example
+@end ifset
+
+@ifset use-tex
+@c @image{FunctionalLayerCake,6in,4in}
+@end ifset
+
+@ifset use-html
+@end ifset
+
+@enumerate
+
+@item Application programs are presented with a standard set of POSIX
+compliant functions that allow them to interface with the files, devices
+and directories in the filesystem. The interfaces to these routines do
+not reflect the type of subordinate filesystem implementation in which
+the file will be found.
+
+@item The filesystem framework developed under RTEMS allows for mounting
+filesystem of different types under the base filesystem.
+
+@item The mechanics of locating file information may be quite different
+between filesystem types.
+
+@item The process of locating a file may require crossing filesystem
+boundaries.
+
+@item The transitions between filesystem and the processing required to
+access information in different filesystem is not visible at the level
+of the POSIX function call.
+
+@item The POSIX interface standard provides file access by character
+pathname to the file in some functions and through an integer file
+descriptor in other functions.
+
+@item The nature of the integer file descriptor and its associated
+processing is operating system and filesystem specific.
+
+@item Directory and device information must be processed with some of the
+same routines that apply to files.
+
+@item The form and content of directory and device information differs
+greatly from that of a regular file.
+
+@item Files, directories and devices represent elements (nodes) of a tree
+hierarchy.
+
+@item The rules for processing each of the node types that exist under the
+filesystem are node specific but are still not reflected in the POSIX
+interface routines.
+
+@end enumerate
+
+
+@example
+Figure of the Filesystem Functional Layering goes here.
+This figure focuses on the Base Filesystem and IMFS.
+@end example
+
+@example
+Figure of the IMFS Memfile control blocks 
+@end example
+
+@section File and Directory Removal Constraints
 
 The following POSIX constraints must be honored by all filesystems.
@@ -33,2 +111,1147 @@
 @end itemize
 
+@c
+@c
+@c
+@section API Layering
+
+@subsection Mapping of Generic System Calls to Filesystem Specific Functions
+
+The list of generic system calls includes the routines open(), read(),
+write(), close(), etc..
+
+The Files and Directories section of the POSIX Application Programs
+Interface specifies a set of functions with calling arguments that are
+used to gain access to the information in a filesystem. To the
+application program, these functions allow access to information in any
+mounted filesystem without explicit knowledge of the filesystem type or
+the filesystem mount configuration. The following are functions that are
+provided to the application:
+
+@enumerate
+@item access()
+@item chdir()
+@item chmod()
+@item chown()
+@item close()
+@item closedir()
+@item fchmod()
+@item fcntl()
+@item fdatasync()
+@item fpathconf()
+@item fstat()
+@item fsync()
+@item ftruncate()
+@item link()
+@item lseek()
+@item mkdir()
+@item mknod()
+@item mount()
+@item open()
+@item opendir()
+@item pathconf()
+@item read()
+@item readdir()
+@item rewinddir()
+@item rmdir()
+@item rmnod()
+@item scandir()
+@item seekdir()
+@item stat()
+@item telldir()
+@item umask()
+@item unlink()
+@item unmount()
+@item utime()
+@item write()
+@end enumerate
+
+The filesystem's type as well as the node type within the filesystem
+determine the nature of the processing that must be performed for each of
+the functions above. The RTEMS filesystem provides a framework that
+allows new filesystem to be developed and integrated without alteration
+to the basic framework.
+
+To provide the functional switching that is required, each of the POSIX
+file and directory functions have been implemented as a shell function.
+The shell function adheres to the POSIX interface standard. Within this
+functional shell, filesystem and node type information is accessed which
+is then used to invoke the appropriate filesystem and node type specific
+routine to process the POSIX function call.
+
+@subsection File/Device/Directory function access via file control block - rtems_libio_t structure
+
+The POSIX open() function returns an integer file descriptor that is used
+as a reference to file control block information for a specific file. The
+file control block contains information that is used to locate node, file
+system, mount table and functional handler information. The diagram in
+Figure 8 depicts the relationship between and among the following
+components.
+
+@enumerate
+
+@item File Descriptor Table
+
+This is an internal RTEMS structure that tracks all currently defined file
+descriptors in the system. The index that is returned by the file open()
+operation references a slot in this table. The slot contains a pointer to
+the file descriptor table entry for this file. The rtems_libio_t structure
+represents the file control block.
+
+@item Allocation of entry in the File Descriptor Table
+
+Access to the file descriptor table is controlled through a semaphore that
+is implemented using the rtems_libio_allocate() function. This routine
+will grab a semaphore and then scan the file control blocks to determine
+which slot is free for use. The first free slot is marked as used and the
+index to this slot is returned as the file descriptor for the open()
+request. After the alterations have been made to the file control block
+table, the semaphore is released to allow further operations on the table.
+
+@item Maximum number of entries in the file descriptor table is
+configurable through the src/exec/sapi/headers/confdefs.h file. If the
+CONFIGURE_LIBIO_MAXIMUM_FILE_DESCRIPTORS constant is defined its value
+will represent the maximum number of file descriptors that are allowed.  
+If CONFIGURE_LIBIO_MAXIMUM_FILE_DESCRIPTORS is not specified a default
+value of 20 will be used as the maximum number of file descriptors
+allowed.
+
+@item File control block - rtems_libio_t structure
+
+@example
+struct rtems_libio_tt @{
+  rtems_driver_name_t               *driver;
+  off_t                              size;      /* size of file */
+  off_t                              offset;    /* current offset into file */
+  unsigned32                         flags;
+  rtems_filesystem_location_info_t   pathinfo;
+  Objects_Id                         sem;
+  unsigned32                         data0;     /* private to "driver" */
+  void                               data1;     / . */
+  void                               file_info; /used by file handlers/
+  rtems_filesystem_file_handlers_r   handlers;  /type specific handlers/
+@};
+@end example
+
+A file control block can exist for regular files, devices and directories.
+The following fields are important for regular file and directory access:
+
+@itemize @bullet
+
+@item Size - For a file this represents the number of bytes currently
+stored in a file. For a directory this field is not filled in.
+
+@item Offset - For a file this is the byte file position index relative to
+the start of the file. For a directory this is the byte offset into a
+sequence of dirent structures.
+
+@item Pathinfo - This is a structure that provides a pointer to node
+information, OPS table functions, Handler functions and the mount table
+entry associated with this node.
+
+@item file_info - A pointer to node information that is used by Handler
+functions
+
+@item handlers - A pointer to a table of handler functions that operate on
+a file, device or directory through a file descriptor index
+
+@end itemize
+
+@end enumerate
+
+@subsection File/Directory function access via rtems_filesystem_location_info_t structure
+
+The rtems_filesystem_location_info_tt structure below provides sufficient
+information to process nodes under a mounted filesystem.
+
+@example
+struct rtems_filesystem_location_info_tt @{
+    void                                         *node_access;
+    rtems_filesystem_file_handlers_r         *handlers;
+    rtems_filesystem_operations_table        *ops;
+    rtems_filesystem_mount_table_entry_t     *mt_entry;
+@};
+@end example
+
+It contains a void pointer to filesystem specific nodal structure,
+pointers to the OPS table for the filesystem that contains the node, the
+node type specific handlers for the node and a reference pointer to the
+mount table entry associated with the filesystem containing the node
+
+@section Operation Tables
+
+Filesystem specific operations are invoked indirectly.  The set of 
+routines that implement the filesystem are configured into two tables.
+The Filesystem Handler Table has routines that are specific to a 
+filesystem but remain constant regardless of the actual file type.
+The File Handler Table has routines that are both filesystem and file type
+specific.
+
+@subsection Filesystem Handler Table Functions
+
+OPS table functions are defined in a @code{rtems_filesystem_operations_table}
+structure.  It defines functions that are specific to a given filesystem.
+One table exists for each filesystem that is supported in the RTEMS
+configuration. The structure definition appears below and is followed by
+general developmental information on each of the functions contained in this
+function management structure.
+
+@example
+typedef struct @{
+  rtems_filesystem_evalpath_t        evalpath;
+  rtems_filesystem_evalmake_t        evalformake;
+  rtems_filesystem_link_t            link;
+  rtems_filesystem_unlink_t          unlink;
+  rtems_filesystem_node_type_t       node_type;
+  rtems_filesystem_mknod_t           mknod;
+  rtems_filesystem_rmnod_t           rmnod;
+  rtems_filesystem_chown_t           chown;
+  rtems_filesystem_freenode_t        freenod;
+  rtems_filesystem_mount_t           mount;
+  rtems_filesystem_fsmount_me_t      fsmount_me;
+  rtems_filesystem_unmount_t         unmount;
+  rtems_filesystem_fsunmount_me_t    fsunmount_me;
+  rtems_filesystem_utime_t           utime;
+  rtems_filesystem_evaluate_link_t   eval_link;
+  rtems_filesystem_symlink_t         symlink;
+@} rtems_filesystem_operations_table;
+@end example
+
+@c
+@c
+@c
+@page
+
+@subsubsection evalpath Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection evalformake Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection link Handler
+
+@subheading Corresponding Structure Element:
+
+link
+
+@subheading Arguments:
+
+
+@example
+rtems_filesystem_location_info_t    *to_loc,      /* IN */
+rtems_filesystem_location_info_t    *parent_loc,  /* IN */
+const char                          *token        /* IN */
+@end example
+
+@subheading File:
+
+imfs_link.c
+
+@subheading Description:
+
+
+This routine is used to create a hard-link.
+
+It will first examine the st_nlink count of the node that we are trying to.
+If the link count exceeds LINK_MAX an error will be returned.
+
+The name of the link will be normalized to remove extraneous separators from
+the end of the name.
+
+@c
+@c
+@c
+@page
+
+@subsubsection unlink Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection node_type Handler
+
+@subheading Corresponding Structure Element:
+
+node_type()
+
+@subheading Arguments:
+
+@example
+rtems_filesystem_location_info_t    *pathloc        /* IN */
+@end example
+
+@subheading File:
+
+imfs_ntype.c
+
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection mknod Handler
+
+@subheading Corresponding Structure Element:
+
+mknod()
+
+@subheading Arguments:
+
+@example
+const char                          *token,        /* IN */
+mode_t                               mode,         /* IN */
+dev_t                                dev,          /* IN */
+rtems_filesystem_location_info_t    *pathloc       /* IN/OUT */
+@end example
+
+@subheading File:
+
+mknod.c
+
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection rmnod Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection chown Handler
+
+@subheading Corresponding Structure Element:
+
+chown()
+
+@subheading Arguments:
+
+@example
+rtems_filesystem_location_info_t    *pathloc        /* IN */
+uid_t                                owner          /* IN */
+gid_t                                group          /* IN */
+@end example
+
+@subheading File:
+
+imfs_chown.c
+
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection freenod Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX 
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection mount Handler
+
+@subheading Corresponding Structure Element:
+
+mount()
+
+@subheading Arguments:
+
+@example
+rtems_filesystem_mount_table_entry_t   *mt_entry
+@end example
+
+@subheading File:
+
+mount.c
+
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection fsmount_me Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+@example
+rtems_filesystem_mount_table_entry_t   *mt_entry    
+@end example
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+This function is provided with a filesystem to take care of the internal
+filesystem management details associated with mounting that filesystem
+under the RTEMS environment.
+
+It is not responsible for the mounting details associated the filesystem
+containing the mount point.
+
+The rtems_filesystem_mount_table_entry_t structure contains the key elements
+below:
+
+rtems_filesystem_location_info_t         *mt_point_node,
+
+This structure contains information about the mount point. This 
+allows us to find the ops-table and the handling functions 
+associated with the filesystem containing the mount point.
+
+rtems_filesystem_location_info_t         *fs_root_node,
+
+This structure contains information about the root node in the file 
+system to be mounted. It allows us to find the ops-table and the 
+handling functions associated with the filesystem to be mounted.
+
+rtems_filesystem_options_t                 options,
+
+Read only or read/write access
+
+void                                         *fs_info,
+
+This points to an allocated block of memory the will be used to 
+hold any filesystem specific information of a global nature. This 
+allocated region if important because it allows us to mount the 
+same filesystem type more than once under the RTEMS system. 
+Each instance of the mounted filesystem has its own set of global 
+management information that is separate from the global 
+management information associated with the other instances of the 
+mounted filesystem type.
+
+rtems_filesystem_limits_and_options_t    pathconf_info,
+
+The table contains the following set of values associated with the 
+mounted filesystem:
+
+@itemize @bullet
+
+@item link_max
+
+@item max_canon
+
+@item max_input
+
+@item name_max
+
+@item path_max
+
+@item pipe_buf
+
+@item posix_async_io
+
+@item posix_chown_restrictions
+
+@item posix_no_trunc
+
+@item posix_prio_io
+
+@item posix_sync_io
+
+@item posix_vdisable
+
+@end itemize
+
+These values are accessed with the pathconf() and the fpathconf ()  
+functions.
+
+const char                                   *dev
+
+The is intended to contain a string that identifies the device that contains
+the filesystem information. The filesystems that are currently implemented
+are memory based and don't require a device specification.
+
+If the mt_point_node.node_access is NULL then we are mounting the base file 
+system.
+
+The routine will create a directory node for the root of the IMFS file
+system.
+
+The node will have read, write and execute permissions for owner, group and
+others.
+
+The node's name will be a null string.
+
+A filesystem information structure(fs_info) will be allocated and
+initialized for the IMFS filesystem. The fs_info pointer in the mount table
+entry will be set to point the filesystem information structure.
+
+The pathconf_info element of the mount table will be set to the appropriate
+table of path configuration constants (LIMITS_AND_OPTIONS).
+
+The fs_root_node structure will be filled in with the following:
+
+@itemize @bullet
+
+@item pointer to the allocated root node of the filesystem
+
+@item directory handlers for a directory node under the IMFS filesystem
+
+@item OPS table functions for the IMFS
+
+@end itemize
+
+A 0 will be returned to the calling routine if the process succeeded,
+otherwise a 1 will be returned.
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection unmount Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX 
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection fsunmount_me Handler
+
+@subheading Corresponding Structure Element:
+
+imfs_fsunmount_me()
+
+@subheading Arguments:
+
+@example
+rtems_filesystem_mount_table_entry_t   *mt_entry    
+@end example
+
+@subheading File:
+
+imfs_fsunmount_me.c
+
+@subheading Description:
+
+XXX 
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection utime Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX 
+
+@c
+@c
+@c
+@page
+
+@subsubsection eval_link Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection symlink Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+@subsection File Handler Table Functions
+
+Handler table functions are defined in a @code{rtems_filesystem_file_handlers_r}
+structure. It defines functions that are specific to a node type in a given
+filesystem. One table exists for each of the filesystem's node types. The
+structure definition appears below. It is followed by general developmental
+information on each of the functions associated with regular files contained
+in this function management structure.
+
+@example
+typedef struct @{
+    rtems_filesystem_open_t           open;
+    rtems_filesystem_close_t          close;
+    rtems_filesystem_read_t           read;
+    rtems_filesystem_write_t          write;
+    rtems_filesystem_ioctl_t          ioctl;
+    rtems_filesystem_lseek_t          lseek;
+    rtems_filesystem_fstat_t          fstat;
+    rtems_filesystem_fchmod_t         fchmod;
+    rtems_filesystem_ftruncate_t      ftruncate;
+    rtems_filesystem_fpathconf_t      fpathconf;
+    rtems_filesystem_fsync_t          fsync;
+    rtems_filesystem_fdatasync_t      fdatasync;
+    rtems_filesystem_fcntl_t          fcntl;
+@} rtems_filesystem_file_handlers_r;
+@end example
+
+@c
+@c
+@c
+@page
+
+@subsubsection open Handler
+
+@subheading Corresponding Structure Element:
+
+open()
+
+@subheading Arguments:
+
+@example
+rtems_libio_t   *iop,
+const char      *pathname,
+unsigned32       flag,
+unsigned32       mode
+@end example
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection close Handler
+
+@subheading Corresponding Structure Element:
+
+close()
+
+@subheading Arguments:
+
+@example
+rtems_libio_t     *iop
+@end example
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@subheading NOTES:
+
+XXX
+
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection read Handler
+
+@subheading Corresponding Structure Element:
+
+read()
+
+@subheading Arguments:
+
+@example
+rtems_libio_t     *iop,
+void              *buffer,
+unsigned32         count
+@end example
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@subheading NOTES:
+
+XXX
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection write Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@subheading NOTES:
+
+XXX
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection ioctl Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+@example
+rtems_libio_t     *iop,
+unsigned32       command,
+void              *buffer
+@end example
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@subheading NOTES:
+
+XXX
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection lseek Handler
+
+@subheading Corresponding Structure Element:
+
+lseek()
+
+@subheading Arguments:
+
+@example
+rtems_libio_t     *iop,
+off_t              offset,
+int                whence
+@end example
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@subheading NOTES:
+
+XXX
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection fstat Handler
+
+@subheading Corresponding Structure Element:
+
+fstat()
+
+@subheading Arguments:
+
+@example
+rtems_filesystem_location_info_t   *loc,
+struct stat                        *buf
+@end example
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+The following information is extracted from the filesystem
+specific node and placed in the @code{stat} structure:
+
+@itemize @bullet
+
+@item st_mode
+
+@item st_nlink
+
+@item st_ino
+
+@item st_uid
+
+@item st_gid
+
+@item st_atime
+
+@item st_mtime
+
+@item st_ctime
+
+@end itemize
+
+
+@subheading NOTES:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection fchmod Handler
+
+@subheading Corresponding Structure Element:
+
+fchmod()
+
+@subheading Arguments:
+
+@example
+rtems_libio_t     *iop
+mode_t              mode
+@end example
+
+@subheading File:
+
+imfs_fchmod.c
+
+@subheading Description:
+
+XXX
+
+
+@subheading NOTES:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection ftruncate Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@subheading NOTES:
+
+XXX
+
+@subsubsection fpathconf Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@subheading NOTES:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection fsync Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@subheading NOTES:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection fdatasync Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@subheading NOTES:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection fcntl Handler
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@subheading NOTES:
+
+XXX
Index: doc/filesystem/imfs.t
===================================================================
--- doc/filesystem/imfs.t	(revision 482ffbb27d1db5c3b0362bdcb9f935beb9d514c2)
+++ doc/filesystem/imfs.t	(revision 7441fe2c5b1275339177a1aef778c9a9620dc462)
@@ -1,12 +1,180 @@
+@c  COPYRIGHT (c) 1988-1998.
+@c  On-Line Applications Research Corporation (OAR).
+@c  All rights reserved.
+@c
+@c  $Id$
+@c
 
 @chapter In-Memory Filesystem 
 
-This chapter describes the In-Memory Filesystem.
-
-@section Filesystem Handler Table Functions
+This chapter describes the In-Memory Filesystem (IMFS).  The IMFS is a
+full featured POSIX filesystem that keeps all information in memory.
+
+@section IMFS Per Node Data Structure
+
+Each regular file, device, hard link, and directory is represented by a data
+structure called a @code{jnode}. The @code{jnode} is formally represented by the
+structure:
+
+@example
+struct IMFS_jnode_tt @{
+  Chain_Node          Node;             /* for chaining them together */
+  IMFS_jnode_t       *Parent;           /* Parent node */
+  char                name[NAME_MAX+1]; /* "basename" */
+  mode_t              st_mode;          /* File mode */
+  nlink_t             st_nlink;         /* Link count */
+  ino_t               st_ino;           /* inode */
+
+  uid_t               st_uid;           /* User ID of owner */
+  gid_t               st_gid;           /* Group ID of owner */
+  time_t              st_atime;         /* Time of last access */
+  time_t              st_mtime;         /* Time of last modification */
+  time_t              st_ctime;         /* Time of last status change */
+  IMFS_jnode_types_t  type;             /* Type of this entry */
+  IMFS_typs_union     info;
+@};
+@end example
+
+The key elements of this structure are listed below together with a brief
+explanation of their role in the filesystem.
+
+@table @b
+
+@item Node
+exists to allow the entire @code{jnode} structure to be included in a chain.
+
+@item Parent
+is a pointer to another @code{jnode} structure that is the logical parent of the
+node in which it appears.  This field may be NULL if the file associated with
+this node is deleted but there are open file descriptors on this file or
+there are still hard links to this node.
+
+@item name
+is the name of this node within the filesystem hierarchical tree. Example:  If
+the fully qualified pathname to the @code{jnode} was @code{/a/b/c}, the
+@code{jnode} name field would contain the null terminated string @code{"c"}.
+
+@item st_mode
+is the standard Unix access permissions for the file or directory.
+
+@item st_nlink
+is the number of hard links to this file. When a @code{jnode} is first created
+its link count is set to 1. A @code{jnode} and its associated resources
+cannot be deleted unless its link count is less than 1.
+
+@item st_ino
+is a unique node identification number
+
+@item st_uid
+is the user ID of the file's owner
+
+@item st_gid
+is the group ID of the file's owner
+
+@item st_atime
+is the time of the last access to this file
+
+@item st_mtime
+is the time of the last modification of this file
+
+@item st_ctime
+is the time of the last status change to the file
+
+@item type
+is the indication of node type must be one of the following states:
+
+@itemize @bullet
+@item IMFS_DIRECTORY 
+@item IMFS_MEMORY_FILE 
+@item IMFS_HARD_LINK
+@item IMFS_SYM_LINK
+@item IMFS_DEVICE 
+@end itemize
+
+
+@item info
+is this contains a structure that is unique to file type (See IMFS_typs_union
+in imfs.h).
+
+@itemize @bullet
+
+@item IMFS_DIRECTORY
+
+An IMFS directory contains a dynamic chain structure that
+records all files and directories that are subordinate to the directory node.
+
+@item IMFS_MEMORY_FILE
+
+Under the in memory filesystem regular files hold data. Data is dynamically
+allocated to the file in 128 byte chunks of memory.  The individual chunks of
+memory are tracked by arrays of pointers that record the address of the
+allocated chunk of memory. Single, double, and triple indirection pointers
+are used to record the locations of all segments of the file.  The
+memory organization of an IMFS file are discussed elsewhere in this manual.
+
+@item IMFS_HARD_LINK
+
+The IMFS filesystem supports the concept of hard links to other nodes in the
+IMFS filesystem.  These hard links are actual pointers to other nodes in the
+same filesystem. This type of link cannot cross-filesystem boundaries.
+
+@item IMFS_SYM_LINK
+
+The IMFS filesystem supports the concept of symbolic links to other nodes in
+any filesystem. A symbolic link consists of a pointer to a character string
+that represents the pathname to the target node. This type of link can
+cross-filesystem boundaries.  Just as with most versions of UNIX supporting
+symbolic links, a symbolic link can point to a non-existent file.
+
+@item IMFS_DEVICE
+
+All RTEMS devices now appear as files under the in memory filesystem. On
+system initialization, all devices are registered as nodes under the file
+system.
+
+@end itemize
+
+@end table
+
+@section Miscellaneous IMFS Information
+
+@section Memory associated with the IMFS
+
+A memory based filesystem draws its resources for files and directories
+from the memory resources of the system. When it is time to un-mount the
+filesystem, the memory resources that supported filesystem are set free.
+In order to free these resources, a recursive walk of the filesystems
+tree structure will be performed. As the leaf nodes under the filesystem
+are encountered their resources are freed. When directories are made empty
+by this process, their resources are freed.
+
+@subsection Node removal constraints for the IMFS
+
+The IMFS conforms to the general filesystem requirements for node
+removal.  See @ref{File and Directory Removal Constraints}.
+
+@subsection IMFS General Housekeeping Notes
+
+The following is a list of odd housekeeping notes for the IMFS.
+
+@itemize @bullet 
+
+@item If the global variable rtems_filesystem_current refers to the node that
+we are trying to remove, the node_access element of this structure must be
+set to NULL to invalidate it.
+
+@item If the node was of IMFS_MEMORY_FILE type, free the memory associated
+with the memory file before freeing the node. Use the IMFS_memfile_remove()
+function.
+
+@end itemize
+
+@section IMFS Operation Tables
+
+@subsection IMFS Filesystem Handler Table Functions
 
 OPS table functions are defined in a rtems_filesystem_operations_table
-structure.  It defines functions that are specific to a given file system.
-One table exists for each file system that is supported in the RTEMS
+structure.  It defines functions that are specific to a given filesystem.
+One table exists for each filesystem that is supported in the RTEMS
 configuration. The structure definition appears below and is followed by
 general developmental information on each of the functions contained in this
@@ -14,85 +182,81 @@
 
 @example
-typedef struct @{
-  rtems_filesystem_evalpath_t        evalpath;
-  rtems_filesystem_evalmake_t        evalformake;
-  rtems_filesystem_link_t            link;
-  rtems_filesystem_unlink_t          unlink;
-  rtems_filesystem_node_type_t       node_type;
-  rtems_filesystem_mknod_t           mknod;
-  rtems_filesystem_rmnod_t           rmnod;
-  rtems_filesystem_chown_t           chown;
-  rtems_filesystem_freenode_t        freenod;
-  rtems_filesystem_mount_t           mount;
-  rtems_filesystem_fsmount_me_t      fsmount_me;
-  rtems_filesystem_unmount_t         unmount;
-  rtems_filesystem_fsunmount_me_t    fsunmount_me;
-  rtems_filesystem_utime_t           utime;
-  rtems_filesystem_evaluate_link_t   eval_link;
-  rtems_filesystem_symlink_t         symlink;
-@} rtems_filesystem_operations_table;
-@end example
-
-
-
-@c
-@c
-@c
-
-@page
-
-@subsection evalpath()
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-
-@c
-@c
-@c
-
-@page
-
-@subsection evalformake()
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-
-@c
-@c
-@c
-
-@page
-
-@subsection link()
-
-@subheading Slot Function:
+rtems_filesystem_operations_table  IMFS_ops = @{
+  IMFS_eval_path,
+  IMFS_evaluate_for_make,
+  IMFS_link,
+  IMFS_unlink,
+  IMFS_node_type,
+  IMFS_mknod,
+  IMFS_rmnod,
+  IMFS_chown,
+  IMFS_freenodinfo,
+  IMFS_mount,
+  IMFS_initialize,
+  IMFS_unmount,
+  IMFS_fsunmount,
+  IMFS_utime,
+  IMFS_evaluate_link,
+  IMFS_symlink,
+  IMFS_readlink
+@};
+@end example
+
+@c
+@c
+@c
+@page
+
+@subsubsection IMFS_evalpath()
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection IMFS_evalformake()
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection IMFS_link()
+
+@subheading Corresponding Structure Element:
 
 link
@@ -111,8 +275,8 @@
 imfs_link.c
 
-@subheading Development Comments:
-
-
-This routine is used in the IMFS file system to create a hard-link.
+@subheading Description:
+
+
+This routine is used in the IMFS filesystem to create a hard-link.
 
 It will first examine the st_nlink count of the node that we are trying to.
@@ -122,5 +286,5 @@
 the end of the name.
 
-IMFS_create_node will be used to create a file system node that will have the
+IMFS_create_node will be used to create a filesystem node that will have the
 following characteristics:
 
@@ -147,36 +311,36 @@
 
 
-@c @c @c
-
-@page
-
-@subsection unlink()
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-
-@c
-@c
-@c
-
-@page
-
-@subsection node_type()
-
-@subheading Slot Function:
+@c
+@c
+@c
+@page
+
+@subsubsection IMFS_unlink()
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection IMFS_node_type()
+
+@subheading Corresponding Structure Element:
 
 IMFS_node_type()
@@ -192,8 +356,8 @@
 imfs_ntype.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine will locate the IMFS_jnode_t structure that holds ownership
-information for the selected node in the file system.
+information for the selected node in the filesystem.
 
 This structure is pointed to by pathloc->node_access.
@@ -216,10 +380,9 @@
 @c
 @c
-
-@page
-
-@subsection mknod()
-
-@subheading Slot Function:
+@page
+
+@subsubsection IMFS_mknod()
+
+@subheading Corresponding Structure Element:
 
 IMFS_mknod()
@@ -238,5 +401,5 @@
 imfs_mknod.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine will examine the mode argument to determine is we are trying to
@@ -255,35 +418,33 @@
 @c
 @c
-
-@page
-
-@subsection rmnod()
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-
-@c
-@c
-@c
-
-@page
-
-@subsection chown()
-
-@subheading Slot Function:
+@page
+
+@subsubsection IMFS_rmnod()
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection IMFS_chown()
+
+@subheading Corresponding Structure Element:
 
 IMFS_chown()
@@ -301,13 +462,13 @@
 imfs_chown.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine will locate the IMFS_jnode_t structure that holds ownership
-information for the selected node in the file system.
+information for the selected node in the filesystem.
 
 This structure is pointed to by pathloc->node_access.
 
 The st_uid and st_gid fields of the node are then modified. Since this is a
-memory based file system, no further action is required to alter the
+memory based filesystem, no further action is required to alter the
 ownership of the IMFS_jnode_t structure.
 
@@ -317,22 +478,21 @@
 @c
 @c
-
-@page
-
-@subsection freenod()
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
+@page
+
+@subsubsection IMFS_freenod()
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
 
 XXX 
@@ -342,10 +502,9 @@
 @c
 @c
-
-@page
-
-@subsection mount()
-
-@subheading Slot Function:
+@page
+
+@subsubsection IMFS_mount()
+
+@subheading Corresponding Structure Element:
 
 IMFS_mount()
@@ -361,8 +520,8 @@
 imfs_mount.c
 
-@subheading Development Comments:
-
-This routine provides the file system specific processing required to mount a
-file system for the system that contains the mount point. It will determine
+@subheading Description:
+
+This routine provides the filesystem specific processing required to mount a
+filesystem for the system that contains the mount point. It will determine
 if the point that we are trying to mount onto is a node of IMFS_DIRECTORY
 type.
@@ -370,21 +529,20 @@
 If it is the node's info element is altered so that the info.directory.mt_fs
 element points to the mount table chain entry that is associated with the
-mounted file system at this point. The info.directory.mt_fs element can be
-examined to determine if a file system is mounted at a directory. If it is
+mounted filesystem at this point. The info.directory.mt_fs element can be
+examined to determine if a filesystem is mounted at a directory. If it is
 NULL, the directory does not serve as a mount point. A non-NULL entry
 indicates that the directory does serve as a mount point and the value of
 info.directory.mt_fs can be used to locate the mount table chain entry that
-describes the file system mounted at this point.
-
-
-@c
-@c
-@c
-
-@page
-
-@subsection fsmount_me()
-
-@subheading Slot Function:
+describes the filesystem mounted at this point.
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection IMFS_fsmount_me()
+
+@subheading Corresponding Structure Element:
 
 IMFS_initialize()
@@ -400,11 +558,11 @@
 imfs_init.c
 
-@subheading Development Comments:
-
-This function is provided with a file system to take care of the internal
-file system management details associated with mounting that file system
+@subheading Description:
+
+This function is provided with a filesystem to take care of the internal
+filesystem management details associated with mounting that filesystem
 under the RTEMS environment.
 
-It is not responsible for the mounting details associated the file system
+It is not responsible for the mounting details associated the filesystem
 containing the mount point.
 
@@ -416,5 +574,5 @@
 This structure contains information about the mount point. This 
 allows us to find the ops-table and the handling functions 
-associated with the file system containing the mount point.
+associated with the filesystem containing the mount point.
 
 rtems_filesystem_location_info_t         *fs_root_node,
@@ -422,5 +580,5 @@
 This structure contains information about the root node in the file 
 system to be mounted. It allows us to find the ops-table and the 
-handling functions associated with the file system to be mounted.
+handling functions associated with the filesystem to be mounted.
 
 rtems_filesystem_options_t                 options,
@@ -431,16 +589,16 @@
 
 This points to an allocated block of memory the will be used to 
-hold any file system specific information of a global nature. This 
+hold any filesystem specific information of a global nature. This 
 allocated region if important because it allows us to mount the 
-same file system type more than once under the RTEMS system. 
-Each instance of the mounted file system has its own set of global 
+same filesystem type more than once under the RTEMS system. 
+Each instance of the mounted filesystem has its own set of global 
 management information that is separate from the global 
 management information associated with the other instances of the 
-mounted file system type.
+mounted filesystem type.
 
 rtems_filesystem_limits_and_options_t    pathconf_info,
 
 The table contains the following set of values associated with the 
-mounted file system:
+mounted filesystem:
 
 @itemize @bullet
@@ -478,5 +636,5 @@
 
 The is intended to contain a string that identifies the device that contains
-the file system information. The file systems that are currently implemented
+the filesystem information. The filesystems that are currently implemented
 are memory based and don't require a device specification.
 
@@ -492,7 +650,7 @@
 The node's name will be a null string.
 
-A file system information structure(fs_info) will be allocated and
-initialized for the IMFS file system. The fs_info pointer in the mount table
-entry will be set to point the file system information structure.
+A filesystem information structure(fs_info) will be allocated and
+initialized for the IMFS filesystem. The fs_info pointer in the mount table
+entry will be set to point the filesystem information structure.
 
 The pathconf_info element of the mount table will be set to the appropriate
@@ -503,7 +661,7 @@
 @itemize @bullet
 
-@item pointer to the allocated root node of the file system
-
-@item directory handlers for a directory node under the IMFS file system
+@item pointer to the allocated root node of the filesystem
+
+@item directory handlers for a directory node under the IMFS filesystem
 
 @item OPS table functions for the IMFS
@@ -518,22 +676,21 @@
 @c
 @c
-
-@page
-
-@subsection unmount()
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
+@page
+
+@subsubsection IMFS_unmount()
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
 
 XXX 
@@ -543,10 +700,9 @@
 @c
 @c
-
-@page
-
-@subsection fsunmount_me()
-
-@subheading Slot Function:
+@page
+
+@subsubsection IMFS_fsunmount_me()
+
+@subheading Corresponding Structure Element:
 
 imfs_fsunmount_me()
@@ -562,5 +718,5 @@
 imfs_fsunmount_me.c
 
-@subheading Development Comments:
+@subheading Description:
 
 XXX 
@@ -570,22 +726,21 @@
 @c
 @c
-
-@page
-
-@subsection utime()
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
+@page
+
+@subsubsection IMFS_utime()
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
 
 XXX 
@@ -595,34 +750,33 @@
 @c
 @c
-
-@page
-
-@subsection eval_link()
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-@c
-@c
-@c
-@page
-@section Regular File Handler Table Functions
+@page
+
+@subsubsection IMFS_eval_link()
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+@subsection Regular File Handler Table Functions
 
 Handler table functions are defined in a rtems_filesystem_file_handlers_r
 structure. It defines functions that are specific to a node type in a given
-file system. One table exists for each of the file system's node types. The
+filesystem. One table exists for each of the filesystem's node types. The
 structure definition appears below. It is followed by general developmental
 information on each of the functions associated with regular files contained
@@ -630,30 +784,30 @@
 
 @example
-typedef struct @{
-    rtems_filesystem_open_t           open;
-    rtems_filesystem_close_t          close;
-    rtems_filesystem_read_t           read;
-    rtems_filesystem_write_t          write;
-    rtems_filesystem_ioctl_t          ioctl;
-    rtems_filesystem_lseek_t          lseek;
-    rtems_filesystem_fstat_t          fstat;
-    rtems_filesystem_fchmod_t         fchmod;
-    rtems_filesystem_ftruncate_t      ftruncate;
-    rtems_filesystem_fpathconf_t      fpathconf;
-    rtems_filesystem_fsync_t          fsync;
-    rtems_filesystem_fdatasync_t      fdatasync;
-@} rtems_filesystem_file_handlers_r;
-@end example
-
-
-@c
-@c
-@c
-
-@page
-
-@subsection open() for Regular Files
-
-@subheading Slot Function:
+rtems_filesystem_file_handlers_r IMFS_memfile_handlers = @{
+  memfile_open,
+  memfile_close,
+  memfile_read,
+  memfile_write,
+  memfile_ioctl,
+  memfile_lseek,
+  IMFS_stat,
+  IMFS_fchmod,
+  memfile_ftruncate,
+  NULL,                /* fpathconf */
+  NULL,                /* fsync */
+  IMFS_fdatasync,
+  IMFS_fcntl
+@};
+@end example
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection memfile_open() for Regular Files
+
+@subheading Corresponding Structure Element:
 
 memfile_open()
@@ -672,5 +826,5 @@
 memfile.c
 
-@subheading Development Comments:
+@subheading Description:
 
 Currently this function is a shell. No meaningful processing is performed and
@@ -680,10 +834,9 @@
 @c
 @c
-
-@page
-
-@subsection close() for Regular Files
-
-@subheading Slot Function:
+@page
+
+@subsubsection memfile_close() for Regular Files
+
+@subheading Corresponding Structure Element:
 
 memfile_close()
@@ -699,7 +852,7 @@
 memfile.c
 
-@subheading Development Comments:
-
-This routine is a dummy for regular files under the base file system. It
+@subheading Description:
+
+This routine is a dummy for regular files under the base filesystem. It
 performs a capture of the IMFS_jnode_t pointer from the file control block
 and then immediately returns a success status.
@@ -709,10 +862,9 @@
 @c
 @c
-
-@page
-
-@subsection read() for Regular Files
-
-@subheading Slot Function:
+@page
+
+@subsubsection memfile_read() for Regular Files
+
+@subheading Corresponding Structure Element:
 
 memfile_read()
@@ -730,5 +882,5 @@
 memfile.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine will determine the @code{jnode} that is associated with this file.
@@ -756,33 +908,31 @@
 @c
 @c
-
-@page
-
-@subsection write() for Regular Files
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-@c
-@c
-@c
-
-@page
-
-@subsection ioctl() for Regular Files
-
-@subheading Slot Function:
+@page
+
+@subsubsection memfile_write() for Regular Files
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection memfile_ioctl() for Regular Files
+
+@subheading Corresponding Structure Element:
 
 XXX
@@ -800,5 +950,5 @@
 memfile.c
 
-@subheading Development Comments:
+@subheading Description:
 
 The current code is a placeholder for future development. The routine returns
@@ -808,10 +958,9 @@
 @c
 @c
-
-@page
-
-@subsection lseek() for Regular Files
-
-@subheading Slot Function:
+@page
+
+@subsubsection memfile_lseek() for Regular Files
+
+@subheading Corresponding Structure Element:
 
 Memfile_lseek()
@@ -829,5 +978,5 @@
 memfile.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine make sure that the memory based file is sufficiently large to
@@ -841,10 +990,9 @@
 @c
 @c
-
-@page
-
-@subsection fstat() for Regular Files
-
-@subheading Slot Function:
+@page
+
+@subsubsection IMFS_stat() for Regular Files
+
+@subheading Corresponding Structure Element:
 
 IMFS_stat()
@@ -861,5 +1009,5 @@
 imfs_stat.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine actually performs status processing for both devices and regular
@@ -867,5 +1015,5 @@
 
 The IMFS_jnode_t structure is referenced to determine the type of node under
-the file system.
+the filesystem.
 
 If the node is associated with a device, node information is extracted and
@@ -903,10 +1051,9 @@
 @c
 @c
-
-@page
-
-@subsection fchmod() for Regular Files
-
-@subheading Slot Function:
+@page
+
+@subsubsection IMFS_fchmod() for Regular Files
+
+@subheading Corresponding Structure Element:
 
 IMFS_fchmod()
@@ -923,5 +1070,5 @@
 imfs_fchmod.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine will obtain the pointer to the IMFS_jnode_t structure from the
@@ -944,33 +1091,27 @@
 @c
 @c
-
-@page
-
-@subsection ftruncate() for Regular Files
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-@c
-@c
-@c
-
-@page
-
-@subsection fpathconf() for Regular Files
-
-@subheading Slot Function:
+@page
+
+@subsubsection memfile_ftruncate() for Regular Files
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+
+@subsubsection No pathconf() for Regular Files
+
+@subheading Corresponding Structure Element:
 
 NULL
@@ -984,5 +1125,5 @@
 Not Implemented
 
-@subheading Development Comments:
+@subheading Description:
 
 Not Implemented
@@ -992,57 +1133,55 @@
 @c
 @c
-
-@page
-
-@subsection fsync() for Regular Files
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-
-@c
-@c
-@c
-
-@page
-
-@subsection fdatasync() for Regular Files
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-@c
-@c
-@c
-@page
-@section Directory Handler Table Functions
+@page
+
+@subsubsection No fsync() for Regular Files
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection IMFS_fdatasync() for Regular Files
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+@subsection Directory Handler Table Functions
 
 Handler table functions are defined in a rtems_filesystem_file_handlers_r
 structure. It defines functions that are specific to a node type in a given
-file system. One table exists for each of the file system's node types. The
+filesystem. One table exists for each of the filesystem's node types. The
 structure definition appears below. It is followed by general developmental
 information on each of the functions associated with directories contained in
@@ -1050,30 +1189,29 @@
 
 @example
-typedef struct @{
-    rtems_filesystem_open_t           open;
-    rtems_filesystem_close_t          close;
-    rtems_filesystem_read_t           read;
-    rtems_filesystem_write_t          write;
-    rtems_filesystem_ioctl_t          ioctl;
-    rtems_filesystem_lseek_t          lseek;
-    rtems_filesystem_fstat_t          fstat;
-    rtems_filesystem_fchmod_t         fchmod;
-    rtems_filesystem_ftruncate_t      ftruncate;
-    rtems_filesystem_fpathconf_t      fpathconf;
-    rtems_filesystem_fsync_t          fsync;
-    rtems_filesystem_fdatasync_t      fdatasync;
-@} rtems_filesystem_file_handlers_r;
-@end example
-
-
-@c
-@c
-@c
-
-@page
-
-@subsection open() for Directories
-
-@subheading Slot Function:
+rtems_filesystem_file_handlers_r IMFS_directory_handlers = @{
+  IMFS_dir_open,
+  IMFS_dir_close,
+  IMFS_dir_read,
+  NULL,             /* write */
+  NULL,             /* ioctl */
+  IMFS_dir_lseek,
+  IMFS_dir_fstat, 
+  IMFS_fchmod,
+  NULL,             /* ftruncate */
+  NULL,             /* fpathconf */
+  NULL,             /* fsync */
+  IMFS_fdatasync,
+  IMFS_fcntl
+@};
+@end example
+
+
+@c
+@c
+@c
+@page
+@subsubsection IMFS_dir_open() for Directories
+
+@subheading Corresponding Structure Element:
 
 imfs_dir_open()
@@ -1092,5 +1230,5 @@
 imfs_directory.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine will look into the file control block to find the @code{jnode} that
@@ -1106,10 +1244,9 @@
 @c
 @c
-
-@page
-
-@subsection close() for Directories
-
-@subheading Slot Function:
+@page
+
+@subsubsection IMFS_dir_close() for Directories
+
+@subheading Corresponding Structure Element:
 
 imfs_dir_close()
@@ -1125,7 +1262,7 @@
 imfs_directory.c
 
-@subheading Development Comments:
-
-This routine is a dummy for directories under the base file system. It
+@subheading Description:
+
+This routine is a dummy for directories under the base filesystem. It
 immediately returns a success status.
 
@@ -1133,10 +1270,9 @@
 @c
 @c
-
-@page
-
-@subsection read() for Directories
-
-@subheading Slot Function:
+@page
+
+@subsubsection IMFS_dir_read() for Directories
+
+@subheading Corresponding Structure Element:
 
 imfs_dir_read
@@ -1154,5 +1290,5 @@
 imfs_directory.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine will read a fixed number of directory entries from the current
@@ -1164,34 +1300,32 @@
 @c
 @c
-
-@page
-
-@subsection write() for Directories
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-@c
-@c
-@c
-
-@page
-
-@subsection ioctl() for Directories
-
-@subheading Slot Function:
+@page
+
+@subsubsection No write() for Directories
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection No ioctl() for Directories
+
+@subheading Corresponding Structure Element:
 
 ioctl
@@ -1204,17 +1338,16 @@
 Not supported
 
-@subheading Development Comments:
-
-XXX
-
-@c
-@c
-@c
-
-@page
-
-@subsection lseek() for Directories
-
-@subheading Slot Function:
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection IMFS_dir_lseek() for Directories
+
+@subheading Corresponding Structure Element:
 
 imfs_dir_lseek()
@@ -1232,5 +1365,5 @@
 imfs_directory.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine alters the offset in the file control block.
@@ -1245,10 +1378,9 @@
 @c
 @c
-
-@page
-
-@subsection fstat() for Directories
-
-@subheading Slot Function:
+@page
+
+@subsubsection IMFS_dir_fstat() for Directories
+
+@subheading Corresponding Structure Element:
 
 imfs_dir_fstat()
@@ -1266,5 +1398,5 @@
 imfs_directory.c
 
-@subheading Development Comments:
+@subheading Description:
 
 The node access information in the rtems_filesystem_location_info_t structure
@@ -1291,10 +1423,9 @@
 @c
 @c
-
-@page
-
-@subsection fchmod() for Directories
-
-@subheading Slot Function:
+@page
+
+@subsubsection IMFS_fchmod() for Directories
+
+@subheading Corresponding Structure Element:
 
 IMFS_fchmod()
@@ -1311,5 +1442,5 @@
 imfs_fchmod.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine will obtain the pointer to the IMFS_jnode_t structure from the
@@ -1332,34 +1463,32 @@
 @c
 @c
-
-@page
-
-@subsection ftruncate() for Directories
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-@c
-@c
-@c
-
-@page
-
-@subsection fpathconf() for Directories
-
-@subheading Slot Function:
+@page
+
+@subsubsection No ftruncate() for Directories
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection No fpathconf() for Directories
+
+@subheading Corresponding Structure Element:
 
 fpathconf
@@ -1373,5 +1502,5 @@
 Not Implemented
 
-@subheading Development Comments:
+@subheading Description:
 
 Not Implemented
@@ -1381,55 +1510,56 @@
 @c
 @c
-
-@page
-
-@subsection fsync() for Directories
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-
-@c
-@c
-@c
-
-@page
-
-@subsection fdatasync() for Directories
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-
-@section Device Handler Table Functions
+@page
+
+@subsubsection No fsync() for Directories
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection IMFS_fdatasync() for Directories
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+@subsection Device Handler Table Functions
 
 Handler table functions are defined in a rtems_filesystem_file_handlers_r
 structure. It defines functions that are specific to a node type in a given
-file system. One table exists for each of the file system's node types. The
+filesystem. One table exists for each of the filesystem's node types. The
 structure definition appears below. It is followed by general developmental
 information on each of the functions associated with devices contained in
@@ -1456,10 +1586,9 @@
 @c
 @c
-
-@page
-
-@subsection open() for Devices
-
-@subheading Slot Function:
+@page
+
+@subsubsection device_open() for Devices
+
+@subheading Corresponding Structure Element:
 
 device_open()
@@ -1478,5 +1607,5 @@
 deviceio.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine will use the file control block to locate the node structure for
@@ -1492,10 +1621,9 @@
 @c
 @c
-
-@page
-
-@subsection close() for Devices
-
-@subheading Slot Function:
+@page
+
+@subsubsection device_close() for Devices
+
+@subheading Corresponding Structure Element:
 
 device_close()
@@ -1511,5 +1639,5 @@
 deviceio.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine extracts the major and minor device driver numbers from the
@@ -1525,10 +1653,9 @@
 @c
 @c
-
-@page
-
-@subsection read() for Devices
-
-@subheading Slot Function:
+@page
+
+@subsubsection device_read() for Devices
+
+@subheading Corresponding Structure Element:
 
 device_read()
@@ -1546,5 +1673,5 @@
 deviceio.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine will extract the major and minor numbers for the device from the -
@@ -1576,33 +1703,31 @@
 @c
 @c
-
-@page
-
-@subsection write() for Devices
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-@c
-@c
-@c
-
-@page
-
-@subsection ioctl() for Devices
-
-@subheading Slot Function:
+@page
+
+@subsubsection device_write() for Devices
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection device_ioctl() for Devices
+
+@subheading Corresponding Structure Element:
 
 ioctl
@@ -1620,5 +1745,5 @@
 deviceio.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This handler will obtain status information about a device.
@@ -1645,10 +1770,9 @@
 @c
 @c
-
-@page
-
-@subsection lseek() for Devices
-
-@subheading Slot Function:
+@page
+
+@subsubsection device_lseek() for Devices
+
+@subheading Corresponding Structure Element:
 
 device_lseek()
@@ -1666,5 +1790,5 @@
 deviceio.c
 
-@subheading Development Comments:
+@subheading Description:
 
 At the present time this is a placeholder function. It always returns a
@@ -1674,10 +1798,9 @@
 @c
 @c
-
-@page
-
-@subsection fstat() for Devices
-
-@subheading Slot Function:
+@page
+
+@subsubsection IMFS_stat() for Devices
+
+@subheading Corresponding Structure Element:
 
 IMFS_stat()
@@ -1694,10 +1817,10 @@
 imfs_stat.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine actually performs status processing for both devices and regular files. 
 
 The IMFS_jnode_t structure is referenced to determine the type of node under the 
-file system. 
+filesystem. 
 
 If the node is associated with a device, node information is extracted and 
@@ -1736,10 +1859,9 @@
 @c
 @c
-
-@page
-
-@subsection fchmod() for Devices
-
-@subheading Slot Function:
+@page
+
+@subsubsection IMFS_fchmod() for Devices
+
+@subheading Corresponding Structure Element:
 
 IMFS_fchmod()
@@ -1756,5 +1878,5 @@
 imfs_fchmod.c
 
-@subheading Development Comments:
+@subheading Description:
 
 This routine will obtain the pointer to the IMFS_jnode_t structure from the
@@ -1778,33 +1900,31 @@
 @c
 @c
-
-@page
-
-@subsection ftruncate() for Devices
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-@c
-@c
-@c
-
-@page
-
-@subsection fpathconf() for Devices
-
-@subheading Slot Function:
+@page
+
+@subsubsection No ftruncate() for Devices
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+@c
+@c
+@c
+@page
+
+@subsubsection No fpathconf() for Devices
+
+@subheading Corresponding Structure Element:
 
 fpathconf
@@ -1818,5 +1938,5 @@
 Not Implemented
 
-@subheading Development Comments:
+@subheading Description:
 
 Not Implemented
@@ -1826,50 +1946,48 @@
 @c
 @c
-
-@page
-
-@subsection fsync() for Devices
-
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
-
-@c
-@c
-@c
-
-@page
-
-@subsection fdatasync() for Devices
+@page
+
+@subsubsection No fsync() for Devices
+
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
+
+@c
+@c
+@c
+@page
+
+@subsubsection No fdatasync() for Devices
 
 Not Implemented
 
-@subheading Slot Function:
-
-XXX
-
-@subheading Arguments:
-
-XXX
-
-@subheading File:
-
-XXX
-
-@subheading Development Comments:
-
-XXX
-
+@subheading Corresponding Structure Element:
+
+XXX
+
+@subheading Arguments:
+
+XXX
+
+@subheading File:
+
+XXX
+
+@subheading Description:
+
+XXX
+
Index: doc/filesystem/init.t
===================================================================
--- doc/filesystem/init.t	(revision 482ffbb27d1db5c3b0362bdcb9f935beb9d514c2)
+++ doc/filesystem/init.t	(revision 7441fe2c5b1275339177a1aef778c9a9620dc462)
@@ -12,5 +12,5 @@
 initialization will be performed. Part of initialization is a call to
 rtems_filesystem_initialize(). This routine will mount the `In Memory File
-System' as the base file system.  Mounting the base file system consists
+System' as the base filesystem.  Mounting the base filesystem consists
 of the following:
 
@@ -25,11 +25,11 @@
 directory handlers and pathconf limits and options.
 
-@item Allocation of a memory region for file system specific global
+@item Allocation of a memory region for filesystem specific global
 management variables
 
-@item Creation of first mount table entry for the base file system
+@item Creation of first mount table entry for the base filesystem
 
 @item Initialization of the first mount table chain entry to indicate that
-the mount point is NULL and the mounted file system is the base file
+the mount point is NULL and the mounted filesystem is the base file
 system
 
@@ -37,5 +37,5 @@
 
 
-After the base file system has been mounted, the following operations are
+After the base filesystem has been mounted, the following operations are
 performed under its directory structure:
 
@@ -48,2 +48,66 @@
 @end itemize
 
+@section Base Filesystem
+
+RTEMS initially mounts a RAM based file system known as the base file system.  
+The root directory of this file system tree serves as the logical root of the
+directory hierarchy (Figure 3). Under the root directory a `/dev' directory
+is created under which all I/O device directories and files are registered as
+part of the file system hierarchy.
+
+@example
+Figure of the tree structure goes here.
+@end example
+
+A RAM based file system draws its management resources from memory. File and
+directory nodes are simply allocated blocks of memory. Data associated with
+regular files is stored in collections of memory blocks. When the system is
+turned off or restarted all memory-based components of the file system are
+lost.
+
+The base file system serves as a starting point for the mounting of file
+systems that are resident on semi-permanent storage media. Examples of such
+media include non- volatile memory, flash memory and IDE hard disk drives
+(Figure 3). File systems of other types will be mounted onto mount points
+within the base file system or other file systems that are subordinate to the
+base file system. The framework set up under the base file system will allow
+for these new file system types and the unique data and functionality that is
+required to manage the future file systems.
+
+@subsection Base Filesystem Mounting
+
+At present, the first file system to be mounted is the `In Memory File
+System'. It is mounted using a standard MOUNT() command in which the mount
+point is NULL.  This flags the mount as the first file system to be
+registered under the operating system and appropriate initialization of file
+system management information is performed (See figures 4 and 5). If a
+different file system type is desired as the base file system, alterations
+must be made to base_fs.c. This routine handles the mount of the base file
+system.
+
+
+@example
+Figure of the mount table chain goes here.
+@end example
+
+
+Once the root of the base file system has been established and it has been
+recorded as the mount point of the base file system, devices are integrated
+into the base file system. For every device that is configured into the
+system (See ioman.c) a device registration process is performed. Device
+registration produces a unique dev_t handle that consists of a major and
+minor device number. In addition, the configuration information for each
+device contains a text string that represents the fully qualified pathname to
+that device's place in the base file system's hierarchy. A file system node
+is created for the device along the specified registration path.
+
+
+@example
+Figure  of the Mount Table Processing goes here.
+@end example
+
+
+Note: Other file systems can be mounted but they are mounted onto points
+(directory mount points) in the base file system.
+
+
Index: doc/filesystem/mounting.t
===================================================================
--- doc/filesystem/mounting.t	(revision 482ffbb27d1db5c3b0362bdcb9f935beb9d514c2)
+++ doc/filesystem/mounting.t	(revision 7441fe2c5b1275339177a1aef778c9a9620dc462)
@@ -17,12 +17,12 @@
 @item The mount point must be a directory. It may have files and other
 directories under it. These files and directories will be hidden when the
-file system is mounted.
+filesystem is mounted.
 
 @item The task must have read/write/execute permissions to the mount point
 or the mount attempt will be rejected.
 
-@item Only one file system can be mounted to a single mount point.
+@item Only one filesystem can be mounted to a single mount point.
 
-@item The Root of the mountable file system will be referenced by the name
+@item The Root of the mountable filesystem will be referenced by the name
 of the mount point after the mount is complete.
 
@@ -30,4 +30,10 @@
 
 @section Mount Table Chain
+
+The mount table chain is a dynamic list of structures that describe
+mounted filesystems a specific points in the filesystem hierarchy. It is
+initialized to an empty state during the base filesystem initialization.
+The mount operation will add entries to the mount table chain. The
+un-mount operation will remove entries from the mount table chain.
 
 Each entry in the mount table chain is of the following type:
@@ -57,14 +63,12 @@
 @section Adding entries to the chain during mount
 
-When a file system is mounted, its presence and location in the file
+When a filesystem is mounted, its presence and location in the file
 system hierarchy is recorded in a dynamic list structure known as a chain.
 A unique rtems_filesystem_mount_table_entry_tt structure is logged for
-each file system that is mounted. This includes the base file system.
+each filesystem that is mounted. This includes the base filesystem.
 
 @section Removing entries from the chain during unmount
 
-When a file system is dismounted its entry in the mount table chain is
+When a filesystem is dismounted its entry in the mount table chain is
 extracted and the memory for this entry is freed.
 
-
-
Index: doc/filesystem/patheval.t
===================================================================
--- doc/filesystem/patheval.t	(revision 482ffbb27d1db5c3b0362bdcb9f935beb9d514c2)
+++ doc/filesystem/patheval.t	(revision 7441fe2c5b1275339177a1aef778c9a9620dc462)
@@ -21,5 +21,5 @@
 the new node to be created.
 
-@item Pathname evaluation is specific to a file system
+@item Pathname evaluation is specific to a filesystem
 
 @item Mechanics of crossing a mount point during the evaluation of a path
@@ -30,11 +30,11 @@
 @itemize @bullet
 
-@item Finding file system node information
+@item Finding filesystem node information
 
-@item Finding file system node handlers
+@item Finding filesystem node handlers
 
-@item Finding file system node operations table
+@item Finding filesystem node operations table
 
-@item Finding mount table entry for the file system that this node is part
+@item Finding mount table entry for the filesystem that this node is part
 of 
 
Index: doc/filesystem/preface.texi
===================================================================
--- doc/filesystem/preface.texi	(revision 482ffbb27d1db5c3b0362bdcb9f935beb9d514c2)
+++ doc/filesystem/preface.texi	(revision 7441fe2c5b1275339177a1aef778c9a9620dc462)
@@ -8,10 +8,11 @@
 
 @ifinfo
-@node Preface, Base Filesystem, Top, Top
+@node Preface, , Top, Top
 @end ifinfo
 @unnumbered Preface
 
-The following file system capabilities have been added to the existing
-RTEMS system:
+This document describes the implementation of the RTEMS filesystem
+infrastructure.  This infrastructure supports the following
+capabilities:
 
 @itemize @bullet
@@ -41,14 +42,14 @@
 @end enumerate
 
-@item Hard links to files and directories are supported
+@item Hard links to files and directories
 
-@item Symbolic links to files and directories are supported
+@item Symbolic links to files and directories
 
 @end itemize
 
-These enhancements have been made to provide the framework for `UNIX like'
-file system support. The POSIX file and directory functions have been
-implemented to allow a standard method of accessing file, device and
-directory information within the file system. The file system concept that
+This has been implemented to provide the framework for a UNIX-like
+file system support. POSIX file and directory functions have been
+implemented that allow a standard method of accessing file, device and
+directory information within file systems. The file system concept that
 has been implemented allows for expansion and adaptation of the file
 system to a variety of existing and future data storage devices. To this
@@ -57,16 +58,26 @@
 
 This framework slightly alters the manner in which devices are handled
-under RTEMS. Devices that are defined under a given RTEMS configuration
-will now be registered as files in a mounted file system. Access to these
-devices and their associated device handlers will be obtained through the
-traditional file system open(), read(), write(), lseek(), fstat() and
-ioctl() functions.
+under RTEMS from that of public release 4.0.0 and earlier.  Devices that
+are defined under a given RTEMS configuration will now be registered as
+files in a mounted file system.  Access to these device drivers and their
+associated devices may now be performed through the traditional file system
+open(), read(), write(), lseek(), fstat() and ioctl() functions in addition
+to the interface provided by the IO Manager in the RTEMS Classic API.
 
-A node structure is maintained for each file, device, and directory in the
-file system. The node structure is used to manage ownership, access
-rights, access time, modification time, and creation time. A union of
-structures within the nodal structure provide for manipulation of file
-data, device selection, or directory content as required by the nodal
-type. Manipulation of these properties is accomplished through the POSIX
-set of file and directory functions.
+An In-Memory File System (IMFS) is included which provides full POSIX
+filesystem functionality yet is RAM based.  The IMFS maintains a
+node structure for each file, device, and directory in each mounted
+instantiation of its file system. The node structure is used to
+manage ownership, access rights, access time, modification time,
+and creation time.  A union of structures within the IMFS nodal
+structure provide for manipulation of file data, device selection,
+or directory content as required by the nodal type. Manipulation of
+these properties is accomplished through the POSIX set of file and
+directory functions.  In addition to being useful in its own right,
+the IMFS serves as a full featured example filesystem.
 
+The intended audience for this document is those persons implementing
+their own filesystem.  Users of the filesystem may find information
+on the implementation useful.  But the user interface to the filesystem
+is through the ISO/ANSI C Library and POSIX 1003.1b file and directory
+APIs.
Index: doc/filesystem/syscalls.t
===================================================================
--- doc/filesystem/syscalls.t	(revision 482ffbb27d1db5c3b0362bdcb9f935beb9d514c2)
+++ doc/filesystem/syscalls.t	(revision 7441fe2c5b1275339177a1aef778c9a9620dc462)
@@ -10,5 +10,5 @@
 
 This set of routines represents the application's interface to files and directories 
-under the RTEMS file system. All routines are compliant with POSIX standards if a 
+under the RTEMS filesystem. All routines are compliant with POSIX standards if a 
 specific interface has been established. The list below represents the routines that have 
 been included as part of the application's interface.
@@ -64,5 +64,5 @@
 This routine is layered on top of the stat() function. As long as the st_mode 
 element in the returned structure follow the standard UNIX conventions, this 
-function should support other file systems without alteration.
+function should support other filesystems without alteration.
 
 @page
@@ -85,8 +85,8 @@
 
 This routine is layered on the rtems_filesystem_evaluate_path() routine and the 
-file system specific OP table function node_type().
-
-The routine node_type() must be a routine provided for each file system since it 
-must access the file systems node information to determine which of the 
+filesystem specific OP table function node_type().
+
+The routine node_type() must be a routine provided for each filesystem since it 
+must access the filesystems node information to determine which of the 
 following types the node is:
 
@@ -99,5 +99,5 @@
 
 This acknowledges that the form of the node management information can vary 
-from one file system implementation to another.
+from one filesystem implementation to another.
 
 RTEMS has a special global structure that maintains the current directory 
@@ -119,5 +119,5 @@
 This routine is layered on the open(), fchmod () and close () functions. As long as 
 the standard interpretation of the mode_t value is maintained, this routine should 
-not need modification to support other file systems.
+not need modification to support other filesystems.
 
 @subheading Development Comments:
@@ -150,5 +150,5 @@
 actually exists. If it does a rtems_filesystem_location_info_t structure will be 
 obtained that allows the shell function to locate the OPS table that is to be used 
-for this file system.
+for this filesystem.
 
 It is possible that the chown() function that should be in the OPS table is not 
@@ -175,5 +175,5 @@
 invoked.
 
-If the file descriptor refers to an entry in the file system, the appropriate handler 
+If the file descriptor refers to an entry in the filesystem, the appropriate handler 
 will be selected using information that has been placed in the file control block for 
 the device (rtems_libio_t structure).
@@ -191,7 +191,7 @@
 
 If none of the upper bits are set in the file descriptor index, the file descriptor 
-refers to an element of the RTEMS file system.
-
-The following sequence will be performed for any file system file descriptor:
+refers to an element of the RTEMS filesystem.
+
+The following sequence will be performed for any filesystem file descriptor:
 
 @enumerate
@@ -203,5 +203,5 @@
 
 @item Determine if there is actually a function in the selected handler table that 
-processes the close() operation for the file system and node type selected. 
+processes the close() operation for the filesystem and node type selected. 
 This is generally done to avoid execution attempts on functions that have not 
 been implemented.
@@ -230,5 +230,5 @@
 memory resources that are required to track an open directory. The code is layered 
 on the close() function and standard memory free () functions. It should not 
-require alterations to support other file systems.
+require alterations to support other filesystems.
 
 @subheading Development Comments:
@@ -288,5 +288,5 @@
 @subheading Processing: 
 
-This routine will alter the permissions of a node in a file system. It is layered on 
+This routine will alter the permissions of a node in a filesystem. It is layered on 
 the following functions and macros:
 
@@ -334,5 +334,5 @@
 This routine currently only interacts with the file control block. If the structure of 
 the file control block and the associated meanings do not change, the partial 
-implementation of fcntl() should remain unaltered for other file system 
+implementation of fcntl() should remain unaltered for other filesystem 
 implementations.
 
@@ -369,7 +369,7 @@
 @subheading Processing: 
 
-This routine is a template in the in memory file system that will route us to the 
+This routine is a template in the in memory filesystem that will route us to the 
 appropriate handler function to carry out the fdatasync() processing. In the in 
-memory file system this function is not necessary. Its function in a disk based file 
+memory filesystem this function is not necessary. Its function in a disk based file 
 system that employs a memory cache is to flush all memory based data buffers to 
 disk. It is layered on the following functions and macros:
@@ -431,6 +431,6 @@
 @end itemize
 
-When a file system is mounted, a set of constants is specified for the file system. 
-These constants are stored with the mount table entry for the file system. These 
+When a filesystem is mounted, a set of constants is specified for the filesystem. 
+These constants are stored with the mount table entry for the filesystem. These 
 constants appear in the POSIX standard and are listed below.
 
@@ -466,5 +466,5 @@
 This routine will find the mount table information associated the file control block 
 for the specified file descriptor parameter. The mount table entry structure 
-contains a set of file system specific constants that can be accessed by individual 
+contains a set of filesystem specific constants that can be accessed by individual 
 identifiers. 
 
@@ -482,8 +482,8 @@
 
 Pathinfo in the file control block is used to locate the mount table entry for the 
-file system associated with the file descriptor.
+filesystem associated with the file descriptor.
 
 The mount table entry contains the pathconf_limits_and_options element. This 
-element is a table of constants that is associated with the file system. 
+element is a table of constants that is associated with the filesystem. 
 
 The name argument is used to reference the desired constant from the 
@@ -506,5 +506,5 @@
 routine. 
 
-If the file descriptor is associated with a node under a file system, the fstat() 
+If the file descriptor is associated with a node under a filesystem, the fstat() 
 routine will map to the fstat() function taken from the node handler table. 
 
@@ -522,5 +522,5 @@
 system nodes.
 
-If the file descriptor is associated with a node under a file system, the following 
+If the file descriptor is associated with a node under a filesystem, the following 
 steps are performed:
 
@@ -549,6 +549,6 @@
 Not defined in the POSIX 1003.1b standard but commonly supported in most 
 UNIX and POSIX system. Ioctl() is a catchall for I/O operations. Routine is 
-layered on external network handlers and file system specific handlers. The 
-development of new file systems should not alter the basic processing performed 
+layered on external network handlers and filesystem specific handlers. The 
+development of new filesystems should not alter the basic processing performed 
 by this routine.
 
@@ -560,5 +560,5 @@
 returned by this handler is then returned to the calling program.
 
-File descriptors that are associated with a file system undergo the following 
+File descriptors that are associated with a filesystem undergo the following 
 processing:
 
@@ -591,5 +591,5 @@
 
 This routine will establish a hard link to a file, directory or a device. The target of 
-the hard link must be in the same file system as the new link being created. A link 
+the hard link must be in the same filesystem as the new link being created. A link 
 to an existing link is also permitted but the existing link is evaluated before the 
 new link is made. This implies that links to links are reduced to links to files, 
@@ -608,8 +608,8 @@
 evaluation of the new name. This macro examines the first characters of the name 
 to see if the name of the new link starts with a rtems_filesystem_is_separator. If it 
-does the search starts from the root of the RTEMS file system; otherwise the 
+does the search starts from the root of the RTEMS filesystem; otherwise the 
 search will start from the current directory.
 
-The OPS table evalformake() function for the parent's file system is used to 
+The OPS table evalformake() function for the parent's filesystem is used to 
 locate the node that will be the parent of the new link. It will also locate the start 
 of the new path's name. This name will be used to define a child under the parent 
@@ -617,11 +617,11 @@
 
 If the parent is found, the routine will determine if the hard link that we are trying 
-to create will cross a file system boundary. This is not permitted for hard-links.
-
-If the hard-link does not cross a file system boundary, a check is performed to 
+to create will cross a filesystem boundary. This is not permitted for hard-links.
+
+If the hard-link does not cross a filesystem boundary, a check is performed to 
 determine if the OPS table contains an entry for the link() function.
 
 If a link() function is defined, the OPS table link () function will be called to 
-establish the actual link within the file system.
+establish the actual link within the filesystem.
 
 The return code from the OPS table link() function is returned to the calling 
@@ -637,6 +637,6 @@
 @subheading Processing: 
 
-This routine is layered on both external handlers and file system / node type 
-specific handlers. This routine should allow for the support of new file systems 
+This routine is layered on both external handlers and filesystem / node type 
+specific handlers. This routine should allow for the support of new filesystems 
 without modification.
 
@@ -649,5 +649,5 @@
 
 If the file descriptor is not associated with a network connection, it is associated 
-with a node in a file system. The following steps will be performed for file system nodes:
+with a node in a filesystem. The following steps will be performed for filesystem nodes:
 
 @enumerate
@@ -682,5 +682,5 @@
 @subheading Processing: 
 
-This routine attempts to create a directory node under the file system. The routine 
+This routine attempts to create a directory node under the filesystem. The routine 
 is layered the mknod() function. 
 
@@ -698,5 +698,5 @@
 @subheading Processing: 
 
-This routine attempts to create a FIFO node under the file system. The routine is 
+This routine attempts to create a FIFO node under the filesystem. The routine is 
 layered the mknod() function. 
 
@@ -715,5 +715,5 @@
 
 This function will allow for the creation of the following types of nodes under the 
-file system:
+filesystem:
 
 @itemize @bullet
@@ -732,9 +732,9 @@
 
 At the present time, an attempt to create a FIFO will result in an ENOTSUP error 
-to the calling function. This routine is layered the file system specific routines 
-evalformake and mknod. The introduction of a new file system must include its 
+to the calling function. This routine is layered the filesystem specific routines 
+evalformake and mknod. The introduction of a new filesystem must include its 
 own evalformake and mknod function to support the generic mknod() function. 
 Under this condition the generic mknod() function should accommodate other 
-file system types without alteration. 
+filesystem types without alteration. 
 
 @subheading Development Comments:
@@ -768,8 +768,8 @@
 creation of a node.
 
-If the pathname is a valid location to create a node, verify that a file system 
+If the pathname is a valid location to create a node, verify that a filesystem 
 specific mknod() function exists.
 
-If the mknod() function exists, call the file system specific mknod () function. 
+If the mknod() function exists, call the filesystem specific mknod () function. 
 Pass the name, mode, device type and the location information associated with the 
 directory under which the node will be created. 
@@ -797,6 +797,6 @@
 system type without keeping a dynamic database of all possible file 
 system types that are valid for the mount operation. Using this method, it 
-is only necessary to configure the file systems that we wish to use into the 
-RTEMS build. Unused file systems types will not be drawn into the build.
+is only necessary to configure the filesystems that we wish to use into the 
+RTEMS build. Unused filesystems types will not be drawn into the build.
 
 char                      *fsoptions,
@@ -808,22 +808,22 @@
 
 This argument is reserved for the name of a device that will be used to 
-access the file system information. Current file system implementations 
-are memory based and do not require a device to access file system 
+access the filesystem information. Current filesystem implementations 
+are memory based and do not require a device to access filesystem 
 information.
 
 char                      *mount_point
 
-This is a pathname to a directory in a currently mounted file system that 
+This is a pathname to a directory in a currently mounted filesystem that 
 allows read, write and execute permissions.
 
 @subheading Processing: 
 
-This routine will handle the mounting of a file system on a mount point. If the 
+This routine will handle the mounting of a filesystem on a mount point. If the 
 operation is successful, a pointer to the mount table chain entry associated with 
-the mounted file system will be returned to the calling function. The specifics 
-about the processing required at the mount point and within the file system being 
-mounted is isolated in the file system specific mount() and fsmount_me () 
+the mounted filesystem will be returned to the calling function. The specifics 
+about the processing required at the mount point and within the filesystem being 
+mounted is isolated in the filesystem specific mount() and fsmount_me () 
 functions. This allows the generic mount() function to remain unaltered even if 
-new file system types are introduced.
+new filesystem types are introduced.
 
 
@@ -834,5 +834,5 @@
 are valid ("RO" or "RW").
 
-It confirms that a file system ops-table has been selected.
+It confirms that a filesystem ops-table has been selected.
 
 Space is allocated for a mount table entry and selective elements of the temporary 
@@ -841,22 +841,22 @@
 If a mount point is specified:
 The mount point is examined to determine that it is a directory and also 
-has the appropriate permissions to allow a file system to be mounted.
+has the appropriate permissions to allow a filesystem to be mounted.
 
 The current mount table chain is searched to determine that there is not 
-another file system mounted at the mount point we are trying to mount 
+another filesystem mounted at the mount point we are trying to mount 
 onto.
 
-If a mount function is defined in the ops table for the file system 
+If a mount function is defined in the ops table for the filesystem 
 containing the mount point, it is called at this time.
 
 If no mount point is specified:
 Processing if performed to set up the mount table chain entry as the base 
-file system.
-
-If the fsmount_me() function is specified for ops-table of the file system being 
-mounted, that function is called to initialize for the new file system.
+filesystem.
+
+If the fsmount_me() function is specified for ops-table of the filesystem being 
+mounted, that function is called to initialize for the new filesystem.
 
 On successful completion, the temporary mount table entry will be placed on the 
-mount table chain to record the presence of the mounted file system.
+mount table chain to record the presence of the mounted filesystem.
 
 @page
@@ -869,7 +869,7 @@
 @subheading Processing: 
 
-This routine is layered on both RTEMS calls and file system specific 
+This routine is layered on both RTEMS calls and filesystem specific 
 implementations of the open() function. These functional interfaces should not 
-change for new file systems and therefore this code should be stable as new file 
+change for new filesystems and therefore this code should be stable as new file 
 systems are introduced.
 
@@ -881,10 +881,10 @@
 It will then test to see if the pathname exists. If it does a 
 rtems_filesystem_location_info_t data structure will be filled out. This structure 
-contains information that associates node information, file system specific 
+contains information that associates node information, filesystem specific 
 functions and mount table chain information with the pathname.
 
 If the create option has been it will attempt to create a node for a regular file along 
 the specified path. If a file already exists along this path, an error will be 
-generated; otherwise, a node will be allocated for the file under the file system 
+generated; otherwise, a node will be allocated for the file under the filesystem 
 that contains the pathname. When a new node is created, it is also evaluated so 
 that an appropriate rtems_filesystem_location_info_t data structure can be filled 
@@ -894,7 +894,7 @@
 structure will be initialized with handler table information, node information and 
 the rtems_filesystem_location_info_t data structure that describes the node and 
-file system data in detail.
-
-If an open() function exists in the file system specific handlers table for the node 
+filesystem data in detail.
+
+If an open() function exists in the filesystem specific handlers table for the node 
 that we are trying to open, it will be called at this time.
 
@@ -917,5 +917,5 @@
 This routine will attempt to open a directory for read access. It will setup a DIR 
 control structure that will be used to access directory information. This routine is 
-layered on the generic open() routine and file system specific directory 
+layered on the generic open() routine and filesystem specific directory 
 processing routines. 
 
@@ -935,5 +935,5 @@
 This routine will obtain the value of one of the path configuration parameters and 
 return it to the calling routine. It is layered on the generic open() and fpathconf () 
-functions. These interfaces should not change with the addition of new file system 
+functions. These interfaces should not change with the addition of new filesystem 
 types.
 
@@ -956,7 +956,7 @@
 @subheading Processing: 
 
-This routine is layered on a set of RTEMS calls and file system specific read 
+This routine is layered on a set of RTEMS calls and filesystem specific read 
 operations. The functions are layered in such a way as to isolate them from 
-change as new file systems are introduced.
+change as new filesystems are introduced.
 
 @subheading Development Comments:
@@ -968,5 +968,5 @@
 will then be sent as the return code from generic read() function.
 
-For file descriptors that are associated with the file system the following sequence 
+For file descriptors that are associated with the filesystem the following sequence 
 will be performed:
 
@@ -1008,5 +1008,5 @@
 
 The routine calls a customized getdents() function that is provided by the user. 
-This routine provides the file system specific aspects of reading a directory. 
+This routine provides the filesystem specific aspects of reading a directory. 
 
 It is layered on the read() function in the directory handler table. This function 
@@ -1022,6 +1022,6 @@
 @subheading Processing: 
 
-This routine will attempt to dismount a mounted file system and then free all 
-resources that were allocated for the management of that file system.
+This routine will attempt to dismount a mounted filesystem and then free all 
+resources that were allocated for the management of that filesystem.
 
 @subheading Development Comments:
@@ -1029,13 +1029,13 @@
 @itemize @bullet
 
-@item This routine will determine if there are any file systems currently mounted 
-under the file system that we are trying to dismount. This would prevent the 
-dismount of the file system.
-
-@item It will test to see if the current directory is in the file system that we are 
-attempting to dismount. This would prevent the dismount of the file system.
+@item This routine will determine if there are any filesystems currently mounted 
+under the filesystem that we are trying to dismount. This would prevent the 
+dismount of the filesystem.
+
+@item It will test to see if the current directory is in the filesystem that we are 
+attempting to dismount. This would prevent the dismount of the filesystem.
 
 @item It will scan all the currently open file descriptors to determine is there is an 
-open file descriptor to a file in the file system that we are attempting to 
+open file descriptor to a file in the filesystem that we are attempting to 
 unmount().
 
@@ -1046,14 +1046,14 @@
 @enumerate
 
-@item Call the file system specific unmount() function for the file system that 
+@item Call the filesystem specific unmount() function for the filesystem that 
 contains the mount point. This routine should indicate that the mount point 
-no longer has a file system mounted below it.
-
-@item Call the file system specific fsunmount_me() function for the mounted 
-file system that we are trying to unmount(). This routine should clean up 
+no longer has a filesystem mounted below it.
+
+@item Call the filesystem specific fsunmount_me() function for the mounted 
+filesystem that we are trying to unmount(). This routine should clean up 
 any resources that are no longer needed for the management of the file 
 system being un-mounted.
 
-@item Extract the mount table entry for the file system that was just dismounted 
+@item Extract the mount table entry for the filesystem that was just dismounted 
 from the mount table chain.
 
